******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #4 USAGESTATS.DO

clear
capture log close
set more off
set mem 1205m
log using "usagestats.slf", replace text

u SCEannual

drop if flaguse~=1
sort CARE
collapse (sum) days use*, by(CARE) 
g use1sh=use1/use
g use2sh=use2/use
g use3sh=use3/use
g use4sh=use4/use
g use5sh=use5/use

list

list CARE use1sh use2sh use3sh use4sh use5sh

egen totuse=sum(use)
egen totdays=sum(days)

g usesh=use/totuse
g dayssh=days/totdays

list CARE usesh dayssh


exit
