******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #16 CSCALC72.DO

clear
capture log close
set more off
set mem 100m
log using "cscalc72.slf", replace text

*****THIS PROGRAM IS USED TO CALC CHANGE IN CS FROM INTRODUCING A CARE PROGRAM UNDER FLAT RATES (NO IBP)

****incW=1
u cscalc7
keep if incW==1
sort w MC elas CAREcase CARE 
g PS=0
g PC=0
replace PS=PA if CARE==0
replace PC=PA if CARE==1
collapse (sum) days csA (max) PS PC, by(w MC elas CAREcase)
g dcs=365*(cs[_n+1]-cs)/days if CAREcase==0 & CAREcase[_n+1]==1
replace PS=PS[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
replace PC=PC[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
drop if CAREcase==1

g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA 
reshape wide dcs PS PC, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PS*
summ PC*

g incW=1
keep dcs* incW PS* PC*
save c:\temp\temp2, replace

clear


****incW=2
u cscalc7
keep if incW==2
sort w MC elas CAREcase CARE 
g PS=0
g PC=0
replace PS=PA if CARE==0
replace PC=PA if CARE==1
collapse (sum) days csA (max) PS PC, by(w MC elas CAREcase)
g dcs=365*(cs[_n+1]-cs)/days if CAREcase==0 & CAREcase[_n+1]==1
replace PS=PS[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
replace PC=PC[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
drop if CAREcase==1

g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA 
reshape wide dcs PS PC, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PS*
summ PC*

g incW=2
keep dcs* incW PS* PC*
append using c:\temp\temp2
save c:\temp\temp2, replace
clear


****incW=3
u cscalc7
keep if incW==3
sort w MC elas CAREcase CARE 
g PS=0
g PC=0
replace PS=PA if CARE==0
replace PC=PA if CARE==1
collapse (sum) days csA (max) PS PC, by(w MC elas CAREcase)
g dcs=365*(cs[_n+1]-cs)/days if CAREcase==0 & CAREcase[_n+1]==1
replace PS=PS[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
replace PC=PC[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
drop if CAREcase==1

g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA 
reshape wide dcs PS PC, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PS*
summ PC*

g incW=3
keep dcs* incW PS* PC*
append using c:\temp\temp2
save c:\temp\temp2, replace
clear



****incW=4
u cscalc7
keep if incW==4
sort w MC elas CAREcase CARE 
g PS=0
g PC=0
replace PS=PA if CARE==0
replace PC=PA if CARE==1
collapse (sum) days csA (max) PS PC, by(w MC elas CAREcase)
g dcs=365*(cs[_n+1]-cs)/days if CAREcase==0 & CAREcase[_n+1]==1
replace PS=PS[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
replace PC=PC[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
drop if CAREcase==1

g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA 
reshape wide dcs PS PC, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PS*
summ PC*


g incW=4
keep dcs* incW PS* PC*
append using c:\temp\temp2
save c:\temp\temp2, replace
clear



****incW=5
u cscalc7
keep if incW==5
sort w MC elas CAREcase CARE 
g PS=0
g PC=0
replace PS=PA if CARE==0
replace PC=PA if CARE==1
collapse (sum) days csA (max) PS PC, by(w MC elas CAREcase)
g dcs=365*(cs[_n+1]-cs)/days if CAREcase==0 & CAREcase[_n+1]==1
replace PS=PS[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
replace PC=PC[_n+1] if CAREcase==0 & CAREcase[_n+1]==1
drop if CAREcase==1

g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA 
reshape wide dcs PS PC, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PS*
summ PC*


g incW=5
keep dcs* incW PS* PC*
append using c:\temp\temp2
save c:\temp\temp2, replace
clear

u c:\temp\temp2
sort incW
collapse (mean) dcs* PS* PC*, by(incW)

list incW dcs110 dcs111 dcs112 dcs113
list PS110 PS111 PS112 PS113 if incW==1
list PC110 PC111 PC112 PC113 if incW==1
list incW dcs160 dcs161 dcs162 dcs163
list PS160 PS161 PS162 PS163 if incW==1
list PC160 PC161 PC162 PC163 if incW==1
list incW dcs210 dcs211 dcs212 dcs213
list PS210 PS211 PS212 PS213 if incW==1
list PC210 PC211 PC212 PC213 if incW==1
list incW dcs260 dcs261 dcs262 dcs263
list PS260 PS261 PS262 PS263 if incW==1
list PC260 PC261 PC262 PC263 if incW==1

exit
