******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #2 MAKEZIP4.DO

clear
capture log close
set more off
set mem 1205m
log using "makezip4.slf", replace text

u SCEannual

* FIRST MATCHING TO ZIP4 OF NEARBY PREMISE ID NUMBERS

summ zip zip4

replace zip4=. if zip4==0

summ zip if zip4==.

sort zip id 

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]

g xid=-id
sort zip xid
replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]

drop xid

* OF THOSE NOT MATCHED, NOW MATCH RANDOMLY WITHIN THE SAME ZIP5

capture drop rnd
g rnd=uniform()
sort zip rnd

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

drop rnd
g rnd=uniform()
sort zip rnd

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

drop rnd
g rnd=uniform()
sort zip rnd

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

drop rnd
g rnd=uniform()
sort zip rnd

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

replace zip4=zip4[_n-1] if zip4==. & zip==zip[_n-1]
replace zip4=zip4[_n+1] if zip4==. & zip==zip[_n+1]

summ zip zip4

save xxx, replace

keep if zip4==.

keep zip

tab zip

*NOW IF EVERYTHING LOOKS OK, RENAME XXX TO BE SCEANNUAL.DTA

exit
